--============================================================================--
--------------------------------------------------------------------------------
-- PLASMA.EX - Simple palsma demo useing RotatePalette() and SetAllPalette().
-- Copyright (c)2004 Hayden McKay - Use Freely :)

-------------------------[ Change the plasma's Speed ]--------------------------
--
constant    Speed   =   2       --  -= Slower   += Faster
--
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--============================================================================--
--------------------------------------------------------------------------------
include graphics.e
include palette.e
include misc.e

constant Entry = repeat(0, 3)
sequence Palette Palette = repeat(Entry, 256)

constant Factor = 2/255
procedure CreatePalette()               --> fills the palette array

    for i = 1 to 256 do
	for j = 1 to 3 do
	    if j = 3 then
		Palette[i][j] = floor(30 * sin((i-1) * PI)) + 32
		else Palette[i][j] = floor(30 * sin((i-1) * PI * Factor)) + 32
	    end if
	end for
    end for
    
end procedure

constant SCREEN = #A0000
procedure FillScreen()                  --> places the bytes (pixels)
    
    for y = 0 to 199 do
	for x = 0 to 319 do
	    poke(
		SCREEN + (y * 320 + x),                 -- co-ord calculation
		(sin(x * y / 319 / 20) * 280)
		+ (cos(y * 120 / 199 / 14) * 160)       -- color calculation
		)
	end for
    end for
    
end procedure

constant VertRetrace = allocate(18)     --> waits until vertical retrace
poke(VertRetrace, {
    #60,                    --    0: pushad
    #66,#C7,#C2,#DA,#03,    --    1: mov dx, #03DA
    #EC,                    --    6: @wait1: in al, dx
    #A8,#08,                --    7: test al, #08
    #75,#FB,                --    9: jnz @wait1
    #EC,                    --    B: @wait2: in al, dx
    #A8,#08,                --    C: test al, #08
    #74,#FB,                --    E: jz @wait2
    #61,                    --   10: popad
    #C3})                   --   11: ret


--------------------------------------------------------------------------------
-- * Main ==>

if not graphics_mode(#13) then
    BlackOut()                          -- black out current palette
    FillScreen()                        -- place all the pixels
    CreatePalette()                     -- create the palette array
    FadeIn(Palette, 0.5)                -- fade the screen in @ ~0.5 secs
    while get_key() = -1 do
	call(VertRetrace)                           -- avoid screen flicker
	SetAllPalette(Palette)                      -- set new palette
	Palette = RotatePalette(Palette, 0, Speed)  -- Rotate Clockwise
    end while
    FadeOut(0.5)
end if
--------------------------------------------------------------------------------
--============================================================================--
